/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              Io (C++)                               */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2006 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: lexem.hpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "boolean.hpp"
#include "elem.hpp"
#include "single_types.hpp"

#ifndef LEXEM_H
#define LEXEM_H

namespace io{

  class Lexem{
    Single_type  lexem_type;
    //champs du type somme:
    Elem<int> i;
    Elem<boolean> b;
    Elem<double> d;
    Elem<string> s;
    Elem<float_triple> ft;
    Elem<float_couple> fc;
    Elem<int_triple> it;
    Elem<int_couple> ic;
    Elem<boolean_triple> bt;
    Elem<boolean_couple> bc;
  public:
    Single_type type() const;
    //constructeurs:
    Lexem(){lexem_type=EMPTY;}
    Lexem(const int& i);
    Lexem(const boolean& b);
    Lexem(const double& d);
    Lexem(const string& s);
    Lexem(const float_triple& ft);
    Lexem(const float_couple& fc);
    Lexem(const int_triple& it);
    Lexem(const int_couple& ic);
    Lexem(const boolean_triple& bt);
    Lexem(const boolean_couple& bc);
    //conversions:
    int & to_int();
    boolean & to_boolean();
    double & to_float();
    double & to_double();
    string & to_string();
    float_triple & to_float_triple();
    float_couple & to_float_couple();
    int_triple & to_int_triple();
    int_couple & to_int_couple();
    boolean_triple & to_boolean_triple();
    boolean_couple & to_boolean_couple();
    const int & to_int()const ;
    const boolean & to_boolean()const ;
    const double & to_float()const ;
    const double & to_double()const ;
    const string & to_string()const ;
    const float_triple & to_float_triple()const ;
    const float_couple & to_float_couple()const ;
    const int_triple & to_int_triple()const ;
    const int_couple & to_int_couple()const ;
    const boolean_triple & to_boolean_triple()const ;
    const boolean_couple & to_boolean_couple()const ;

    virtual ~Lexem();
  };

}

#endif
