/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              Io (C++)                               */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2006 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: send.hpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "single_types.hpp"

#ifndef _SEND_H
#define _SEND_H


using namespace std;

/* See ../caml/io.mli for the definition of the communication protocol. */


/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

namespace io{

  /////////////
  //*********//
  //*TO SEND*//
  //*********//
  /////////////


  
  
  template<class dataType> void send(ostream& ob, const dataType& t);
  template<class dataType> void send(ostream& ob, const vector<dataType>& t);
  
  void send_string (ostream& ob,const string& t);
  void send_boolean (ostream& ob,const boolean& b);
  void send_boolean_couple (ostream& ob,const boolean_couple& c);
  void send_boolean_triple (ostream& ob,const boolean_triple& c);
  void send_int (ostream& ob,const int& i);
  void send_int_couple (ostream& ob,const int_couple& c);
  void send_int_triple (ostream& ob,const int_triple& c);
  void send_float (ostream& ob,const double& x);
  void send_float_couple (ostream& ob,const float_couple& x);
  void send_float_triple (ostream& ob,const float_triple& x);
  void send_int_float_couple(ostream& ob,const int_float_couple& x);
  void send_float_int_couple(ostream& ob,const float_int_couple& x);
  void send_int_string_couple(ostream& ob,const int_string_couple& x);
  void send_string_int_couple(ostream& ob,const string_int_couple& x);
  void send_string_float_couple(ostream& ob,const string_float_couple& x);
  void send_float_string_couple(ostream& ob,const float_string_couple& x);
  void send_string_vector (ostream& ob,const vector<string>& v);
  void send_boolean_vector (ostream& ob,const vector<boolean>& v);
  void send_boolean_couple_vector (ostream& ob,const vector<boolean_couple>& v);
  void send_boolean_triple_vector (ostream& ob,const vector<boolean_triple>& v);
  void send_int_vector (ostream& ob,const vector<int>& v);
  void send_int_couple_vector (ostream& ob,const vector<int_couple>& v);
  void send_int_triple_vector (ostream& ob,const vector<int_triple>& v);
  void send_float_vector (ostream& ob,const vector<double>& v);
  void send_float_couple_vector (ostream& ob,const vector<float_couple>& v);
  void send_float_triple_vector (ostream& ob,const vector<float_triple>& v);
  
  void send_row_float_matrix(ostream& ob,const int& m,const int& n,double** & M);
  void send_row_float_matrix(ostream& ob,const int& m,const int& n,double* & M);
  void send_column_float_matrix(ostream& ob,const int& m,const int& n,double** & M);
  void send_column_float_matrix(ostream& ob,const int& m,const int& n,double* & M);//a rebaptiser
  //
  void send_row_to_row_float_matrix(ostream& ob,const int& m,const int& n,double* & M);
  void send_row_to_column_float_matrix(ostream& ob,const int& m,const int& n,double* & M);
  void send_column_to_row_float_matrix(ostream& ob,const int& m,const int& n,double* & M);
  void send_column_to_column_float_matrix(ostream& ob,const int& m,const int& n,double* & M);
  void send_float_array(ostream& ob,const int& m,double*& M);


  
}


#endif

